<!DOCTYPE html>
<html>

<head>
  <title>Task 33.20.2 - User Update </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body >
  
  <div class="div-background-picture">

  
  <div class="container jumbotron div-container-jumbotron  ">
    <div class="col-sm-12 ">
      <div class="text-center mb-5 " > <h1 style="color:rgb(32, 207, 140)"> User Detail</h1> </div>
      <div class="row form-group">   
          <div class="col-sm-4 col-form-label">
            <label >First Name</label>
          </div>
          <div class="col-sm-8">
            <input id="inp-first-name" type="text" class="form-control" placeholder="input firstname">
          </div>
      </div>
      <div class="row form-group">
          <div class="col-sm-4 col-form-label">
            <label >Last Name</label>
          </div>
          <div class="col-sm-8">
            <input id="inp-last-name" type="text" class="form-control" placeholder="input lastname">
          </div>
      </div>
      <div class="row form-group">
          <div class="col-sm-4 col-form-label">
            <label >Subject</label>
          </div>
          <div class="col-sm-8">
            <input id="inp-subject" type="text" class="form-control" placeholder="input subject">
          </div>
      </div>
      <div class="row form-group">
          <div class="col-sm-4 ">
            <label >Country</label>
          </div>
          <div class="col-sm-8">
            <select id="select-country" class="form-control">
              <option value="VN"> Vietnam</option>
              <option value="USA"> USA</option>
              <option value="AUS"> Australia</option>
              <option value="CAN"> Canada</option>
            </select>
          </div>
      </div>
      <div class="row form-group">
          <div class="col-sm-4 col-form-label">
            <label >Customer Type</label>
          </div>
          <div class="col-sm-8">
            <select id="select-customer-type" class="form-control">
              <option value="Standard"> Standard </option>
              <option value="Gold"> Gold </option>
              <option value="Premium"> Premium </option>
            </select>
          </div>
      </div>
      <div class="row form-group">
          <div class="col-sm-4 col-form-label">
            <label >Register Status</label>
          </div>
          <div class="col-sm-8 form-group">
            <select id="select-register-status" class = "form-control">
              <option value="New"> New </option>            
              <option value="Accepted"> Accepted </option>
              <option value="Denied"> Denied </option>
            </select>
          </div>
      </div>
      <div class="row">
        <div class="col-sm-4 form-group">
        </div>
        <div class="col-sm-8"> <!--Buttons-->
          <a id="btn-update-click" class="col-3 btn btn-success">Update user</a>
          <a id="btn-cancel-click" class="col-3 btn btn-primary ">Cancel</a>
          <a id="btn-return-click" class="col-3 btn btn-warning " href = "/33.20 - List of user.html">Return</a>
        </div>
      </div>        
    </div> 
  </div>
  
</div>

</body>
<style>

    .div-background-picture {
        background-image: url("images/signup-bg.jpg");
        height: auto;
        background-position: center;
        background-repeat: no-repeat;
        background-size: cover;
        opacity: 0.6;
        margin-bottom: 0px;
    }
    .div-container-jumbotron {
        padding: 40px;
        background-color: white;
        border-radius: 15px;
    }

    .div-create-account {
        margin-top: -70px;
        font-family:Arial, Helvetica, sans-serif
    }

    .div-input-box {
        border-radius: 8px;
        height: 60px;
        opacity: 0.7;
        margin-bottom: 22px;
    }

    .div-button {
        height: 50px;
    }
</style>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
   const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

   var gFirstNameElement = $("#inp-first-name");
   var gLastNameElement = $("#inp-last-name");
   var gSubjectElement = $("#inp-subject");
   var gCountryElement = $("#select-country");
   var gCustomerTypeElement = $("#select-customer-type");
   var gRegisterStatusElement = $("#select-register-status");
 
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
 
  //load the page
  $(document).ready(function(){onPageLoading()});
  
  //add click event for Update button
  $("#btn-update-click").on("click", btnUpdateUserClick);


  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  
  //function for loading event
  function onPageLoading(){

    var vId = getCurrentUserId()
    console.log("vID: " , vId);
    callApiGetDataUserById(vId);

  }

  //function for getting id from the query string
  function getCurrentUserId(){
    //get data from query string
    var vUrlString = window.location.href;
    var vUrl = new URL(vUrlString);
    //get parameter
    var vId = vUrl.searchParams.get("id");

    return vId;
  }

  //function for calling API from server
  function callApiGetDataUserById(parameter){
    $.ajax({
      url: gBASE_URL + parameter,
      type: "GET",
      success: function(result){
        console.log(result);
        displayDataOnWeb(result);
      },
      error: function(ajaxContext){
        console.log(ajaxContext.responseText);
      }
    });
  }

  //function for displaying data on the web
  function displayDataOnWeb(paramData){

    $("#inp-first-name").val(paramData.firstname);
    $("#inp-last-name").val(paramData.lastname);
    $("#inp-subject").val(paramData.subject);
    $("#select-country").val(paramData.country);
    $("#select-customer-type").val(paramData.customerType);
    $("#select-register-status").val(paramData.registerStatus);

  }

  //function for Update Button
  function btnUpdateUserClick(){

    //get data from web
    var vUserData = getWebData();

    //validate the data
    var vValidResult = validateUpdateData(vUserData);

    //update the data
    if (vValidResult == true){
        updateDataByApiCall(vUserData);
    }


  }

  //function for getting the data
  function getWebData(){

    var vUserObject = new Object;

    vUserObject.firstname = $.trim(gFirstNameElement.val());
    vUserObject.lastname = $.trim(gLastNameElement.val());
    vUserObject.subject = $.trim(gSubjectElement.val());
    vUserObject.country = $.trim(gCountryElement.val());
    vUserObject.customerType = $.trim(gCustomerTypeElement.val());
    vUserObject.registerStatus = $.trim(gRegisterStatusElement.val());
  
    return vUserObject;
  }

  //function for validating the data
  function validateUpdateData(paramData){

    if (paramData.firstname == ""){
      alert("Please input firstname !!!");
      return false;
    }
    if (paramData.lastname == ""){
      alert("Please input lastname !!!");
      return false;
    }
    if (paramData.subject == ""){
      alert("Please input subject !!!");
      return false;
    }
    if (paramData.country == ""){
      alert("Please choose the country !!!");
      return false;
    }
    if (paramData.customerType == ""){
      alert("Please choose the customer's type !!!");
      return false;
    }
    if (paramData.registerStatus == ""){
      alert("Please choose the register status !!!");
      return false;
    }
    return true;
  }

  //funtion for updating the data to the server
  function updateDataByApiCall(paramData){

    var vId = getCurrentUserId();

    $.ajax({
      url: gBASE_URL + vId,
      type: "PUT",
      contentType: "application/json",
      data: JSON.stringify(paramData),
      success: function(res){
        console.log("%cUPDATED INFORMATION: ", "color:orange", Object.entries(res));
        console.log("%cJSON: ", "color:orange", JSON.stringify(res, true, 2));
      },
      error: function(ajaxContext){
        console.log(ajaxContext.status);
      },
    })

  }


  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
 

  
</script>

</html>
